*                      Array MULTI - BINARY INSERTION SORT
*                               and LOCATE
*                          PWITTE April 21st 1993
*
        section code

        xdef BINSORT

        xref mltinfo            ;get parameters
        xref ms_quit            ;exit routine for multi
        xref mlt_dcmpel         ; in quicksort
*
BINSORT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* SuperBASIC function to sort an array of any type based on a
* Binary INsertion SORT algorithm (This sort is stable, but slow. Use for
* arrays of less than 1000 elements)
*
* BINSORT [index% ! ] [ # ] array [ ; [ + | - ]comparison_type% ] [ , ... ] *
*       where index% is an integer array of no more than DIMN(array) elements
*             each element being a unique pointer to an element in array
*       and   array is a single or multiple (but does it make sense?) dimensioned
*             array of any current qdos type, or an array slice (though not
*             a single dimension string).
*        or   a reference to an array as above preceded by a hash
*       and   comparison_type% is the type of comparison required
*             types are as for +/-(Qdos type + 1)
*             Default = 1 = Qdos type 0
*             The comparison type sign indicates ascending (+, implicit)
*             or descending (-) order
*
        bsr mltinfo
        bne.s is_rts
        subq.l #1,d7            ;convert count to hiel no.
is_muls
        pea ms_quit             ;sort return (w error if any)
        move.l a2,d0            ;index or direct?
        beq.s is_dm
* is_im                         ;indexed multi-sort
        asl.l #1,d7
        add.l a2,d7
        move.l d7,a3
        bra.s bin_mind
is_rts
        rts
is_dm                           ;direct multi-sort
        sub.l a2,a2             ;loel
        move.l d7,a3            ;hiel
        bra bin_mdir
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                      Binary search sub-routine for INSORT
*
* input : d5.l  comp type (see quicksort for details)
*         d6.l = element size
*         a1 -> element to comapre against
*         a2 ->> lo
*         a3 ->> hi (both include index base address)
*         a4 -> comp routine ( el_cmp(a4) )
*         a5 =  array base address
* output : a1 ->        insertion position ("found" or "not found" at)
*
*         d0-d3/d7 smashed. No other regs affected
*
* Notes:
* From ind_sex the point has been to adjust the result so as to hit the *first*
* position from the end of the element list that matches the criteria. A pure
* binary search may end on a random target if there are multiple matches:
* that does not produce a stable sort
*
ind_sbin
        move.l a3,d3            ;a3 ->> hi
        move.l a2,d2            ;a2 ->> lo
ind_sloop
        cmp.l d3,d2             ;hi<lo?
        bgt.s ind_sex           ;exit
        move.l d2,d5
        add.l d3,d5
        asr.l #1,d5             ;(hi+lo) div 2
        bclr #0,d5              ;we're dealing with *word* pointers here
        move.w 0(a6,d5.l),d0
        bsr mlt_dcmpel          ;comparison routine
        beq.s ind_sex
        blt.s ind_slo
* ind_shi
        move.l d5,d2
        addq.l #2,d2
        bra.s ind_sloop
ind_slo
        move.l d5,d3
        subq.l #2,d3
        bra.s ind_sloop
ind_sex
        move.w 0(a6,a3.l),d0
        bsr mlt_dcmpel
        blt.s ind_sls
        movea.l a3,a1           ;a1 = result
        addq.l #2,a1            ;
ind_sret
        rts
ind_salp
        move.w 0(a6,d2.l),d0
        bsr mlt_dcmpel
        blt.s ind_sle
        addq.l #2,d2
ind_sls
        cmpa.l d2,a3
        bge.s ind_salp
        subq.l #2,d2
ind_sle
        move.l d2,a1
        bra.s ind_sret
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                 Binary Insertion Sort routine
*
* input : d5.l  comp type (see quicksort for details)
*         d6.l = element size
*         a0 -> element to compare against
*         a2 ->> lo
*         a3 ->> hi (both include index base address)
*         a4 -> comp routine ( el_cmp(a4) )
*         a5 =  array base address
* output : a1 ->        insertion position ("found" or "not found" at)
*
*         d0-d3/d7 smashed. No other regs affected
*
bin_mind
        move.l a3,d3            ;hi
        move.l a2,d2            ;lo
bin_siloop
        addq.l #2,d2            ;for j=1 to dimn(index)...
        cmpa.l d2,a3
        blt.s bin_siex
        move.w 0(a6,d2.l),d0    ;convert pointer to address
*
*                  Multi get-element routine (direct)
* Get the partition element for each array and store
* Include "excluded" arrays for ppointer comparison
*
        movem.l d4-d6/a3-a5,-(a7)
        move.l a5,a3
        move.l d0,d7                    ;awkward all this
mlt_gl
        movem.l (a3)+,d0/d5-d6/a0/a4-a5
        move.l d7,d0                    ;get el num
        mulu d6,d0                      ;multiply by elsize
        add.l a5,d0                     ;add base
        move.l d0,-12(a3)               ;put pp in place
mlt_g
        dbra d4,mlt_gl
        movem.l (a7)+,d4-d6/a3-a5
*
        movem.l d2-d3/a2-a3,-(a7)
        move.l d2,d3
        move.l a2,d2
        subq.l #2,d3
        move.l d3,a3
        bsr ind_sloop
        movem.l (a7)+,d2-d3/a2-a3

        move.w 0(a6,d2.l),d0    ;d0 = tmp
        move.l d2,d1
bin_simloop                     ;shift index elements up targeting vacated
        move.w -2(a6,d1.l),0(a6,d1.l)  ; pp first
        subq.l #2,d1
        cmpa.l d1,a1
        blt.s bin_simloop
        tst.b $8f(a6)           ;break?
        bge.s bin_nc
        move.w d0,0(a6,a1.l)    ;put tmp into target position

        bra.s bin_siloop
bin_nc
        moveq #-1,d0            ;not complete
        rts
bin_siex
        moveq #0,d0
        rts
bin_mdir
        moveq #-19,d0           ;not (yet) implemented
        rts

        end
