* MATSWAP - SuperBASIC routine to swap two arrays of the same type
* PWITTE August 26th 1995
*
* Based on the assumption that BASIC won't notice that the pointers to the
* array data have been changed!
*
        section mat
        filetype 0
*
        lea.l   keyw,a1
        move.w  $110,a2
        jmp     (a2)
*
keyw
        dc.w    1
        dc.w    MATSWAP-*
        dc.b    7,'MATSWAP'
        dc.w    0,0,0
*
MATSWAP
        lea.l   16(a3),a4       ;looking for exactly two parameters..
        cmp.l   a4,a5
        bne.s   ms_bp
        move.w  #$0f0f,d0       ;d0 = info mask
        move.w  0(a6,a3.l),d1   ;first parameter
        and.w   d0,d1           ;strip unrequired info
        and.w   8(a6,a3.l),d0   ;same for next parameter
        cmp.w   d0,d1           ;are pars of the same kind and type?
        bne.s   ms_bp           ; no, no can do
        lsr.w   #8,d0
        subq.w  #3,d0           ;arrays?
        bne.s   ms_bp           ; no, no can do
*
        movea.l a3,a1           ;start search prior to here
        move.l  $18(a6),d0      ; and down to base of name table
        trap    #0              ;need to be in supervisor mode for this
*
        bsr.s   ms_search       ;search for original pointer to array data
        bne.s   ms_rts          ;not found
        movea.l a2,a4           ;a4 -> first array data pointer
        addq.l  #8,a3           ;do the same for next array
        bsr.s   ms_search
        bne.s   ms_rts
        move.l  4(a6,a4.l),d1   ;now swap data pointers
        move.l  4(a6,a2.l),4(a6,a4.l)
        move.l  d1,4(a6,a2.l)
        moveq   #0,d0
ms_rts
        andi.w  #$dfff,sr       ;exit supervisor mode
        tst.l   d0              ;set condition codes to error status
        rts                     ; and return
ms_search
        move.l  4(a6,a3.l),a0   ;get pointer to our array
        adda.l  $28(a6),a0
        move.l  0(a6,a0.l),d1
        beq.s   ms_bp           ;array is unset! (only likely in SBASIC)
        movea.l a1,a2           ;start search from entry prior to first par
ms_loop
        subq.l  #8,a2           ;point to previous name table entry
        move.l  4(a6,a2.l),a0   ;a0 -> array descriptor
        adda.l  $28(a6),a0      ;convert to offset from name table
        cmp.l   0(a6,a0.l),d1   ;is this data pointer same as ours?
        beq.s   ms_exit
        cmp.l   a2,d0           ;end of search?
        blt.s   ms_loop         ; no, continue
ms_bp
        moveq   #-15,d0
ms_exit
        rts
*
*
        end
