*                       Array MULTI - QUICKSORT
*                        PWITTE April 4th 1993
*
        section code

        xdef QUICKSORT
        xdef mlt_dcmpel

        xref mltinfo            ;get parameters
        xref ms_quit            ;exit routine for multi
*
el_cmp  equ 2
el_swp  equ 0
*
qs_rts
        rts
*
QUICKSORT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* SuperBASIC function to sort an array of any type
*
* QUCKSORT [index% ! ] [ # ] array [ ; [ + | - ]comparison_type% ] [ , ... ] *
*       where index% is an integer array of no more than DIMN(array) elements
*             each element being a unique pointer to an element in array
*       and   array is a single or multiple (but does it make sense?) dimensioned
*             array of any current qdos type, or an array slice (though not
*             a single dimension string).
*        or   a reference to an array as above preceded by a hash
*       and   comparison_type% is the type of comparison required
*             types are as for +/-(Qdos type + 1)
*             Default = 1 = Qdos type 0
*             The comparison type sign indicates ascending (+, implicit)
*             or descending (-) order
*
*        dc.l $4AFBEDEB          breakpoint

        bsr mltinfo
        bne.s qs_rts
        subq.l #1,d7            ;convert count to hiel no.
qs_muls
        pea ms_quit             ;sort return
        move.l #-1,-(a7)                ;recursion end marker
        move.l a2,d0            ;index or direct?
        beq.s qs_dm
* qs_im                         ;indexed multi-sort
        asl.l #1,d7
        add.l a2,d7
        move.l a2,-(a7)
        move.l d7,-(a7)
        bra mind_qsort
qs_dm                           ;direct multi-sort
        clr.l -(a7)             ;loel
        move.l d7,-(a7)         ;hiel
        bra.s mdir_qsort
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                            Register usage
*
* d0.l = general register (volatile)
* d1.l = general register: used in flp_cmp, str_swp
* d2.l = running pointer to lower element
* d3.l = running pointer to upper element
* d4.l = counter reserved for multi
* d5.l = bit 31 = direction, bit 7 "exclude", byte: cmp type (QDOS, string)
* d6.l = element size
* d7.w = general register: count in str_swp
*
* a0  -> partition element
* a1  -> comparison element
* a2  -> lower element limit
* a3  -> upper element limit
* a4  -> type dependent sub routines
* a5   = array base register / base register for mutli-array data memory
* a6   = SB stack pointer
* a7   = usp: -> storage
*
*
mlt_dcmpel
*
*                     Multi direct compare routine.
* Do a cmpel for each array: Comparison ends when the result is
* either "greater" or "less" or until there are no further elements left to
* compare in which case the result is "equal".
* Exclude "excluded" arrays
*
        movem.l d4-d6/a3-a5,-(a7)
        move.l a5,a3
        move.l d0,d7
mlt_cl
        tst.b 7(a3)                     ;excluded?
        bpl.s mlt_c                     ; yes, move to next array
        lea.l 24(a3),a3
        dbra d4,mlt_cl
        tst.l d0                        ;??? has to be tested from last
        bra.s mlt_cend                  ; but what if all excluded????
mlt_c                                   ;not excluded
        movem.l (a3)+,d0/d5-d6/a0/a4-a5
        move.l d7,d0
        mulu d6,d0
        add.l a5,d0
        move.l d0,a1
        jsr el_cmp(a4)                  ;cmpel
        dbne d4,mlt_cl
mlt_cend
        movem.l (a7)+,d4-d6/a3-a5
        rts
*
mdir_qsort
         move.l (a7)+,a3                        ;a3 = highest
         move.l (a7)+,a2                        ;a2 = lowest
         move.l a2,d2                   ;d2 = lo el no
mdir_partition
*
* Partition at (hi+lo)/2
*
         move.l a3,d3                   ;d3 = hielno
         move.l d3,d0
         add.l a2,d0
         asr.l #1,d0                    ;d0 = ppno
*
*                  Multi get-element routine (direct)
* Get the partition element for each array and store
* Include "excluded" arrays for ppointer comparison
*
        movem.l d4-d6/a3-a5,-(a7)
        move.l a5,a3
        move.l d0,d7                    ;awkward all this
mlt_gl
        movem.l (a3)+,d0/d5-d6/a0/a4-a5
        move.l d7,d0                    ;get el num
        mulu d6,d0                      ;multiply by elsize
        add.l a5,d0                     ;add base
        move.l d0,-12(a3)               ;put pp in place
mlt_g
        dbra d4,mlt_gl
        movem.l (a7)+,d4-d6/a3-a5
*
mdir_uloop

         move.l d2,d0
         bsr.s mlt_dcmpel

         ble.s mdir_lloop
         addq.l #1,d2                   ;point to next
         bra.s mdir_uloop
mdir_lloop
         move.l d3,d0
         bsr.s mlt_dcmpel

         bge.s mdir_swap
         subq.l #1,d3                   ;-> previous
         bra.s mdir_lloop
mdir_swap
         cmp.l d3,d2
         bgt.s mdir_stack
         beq.s mdir_redgap
*
* Multi-swap. Swap the relevant items in each array (including "excluded" ones)
* and alter any pp's that have been swapped out
*
        movem.l d2-d6/a3-a5,-(a7)
        move.l a5,a3
mlt_sl
        movem.l (a3)+,d0/d5-d6/a0/a4-a5
        move.l (a7),d2                  ;get elnos
        move.l 4(a7),d3
        mulu d6,d2                      ;convert to pointers
        add.l a5,d2
        mulu d6,d3
        add.l a5,d3
        jsr el_swp(a4)                  ;swap routine
        move.l a0,-12(a3)               ;in case ppointer altered
        dbra d4,mlt_sl
        movem.l (a7)+,d2-d6/a3-a5
*
mdir_redgap
         addq.l #1,d2                   ;move pointers closer
         subq.l #1,d3
         cmp.l d3,d2
         ble.s mdir_uloop
mdir_stack
         cmp.l a2,d3                    ;pointers cross?
         ble.s mdir_nostk
         move.l a2,-(a7)
         move.l d3,-(a7)
mdir_nostk
         move.l d2,a2
         cmp.l a3,d2
         blt mdir_partition
         cmpi.l #-1,(a7)                        ;test recursion depth
         bne mdir_qsort
         addq.l #4,a7                   ;remove end marker
         moveq #0,d0
         rts                            ;goto to s_exit
*
mind_qsort
         move.l (a7)+,a3                        ;a3 = highest
         move.l (a7)+,a2                        ;a2 = lowest
         move.l a2,d2                   ;d2 = lo el

mind_partition
*
* add hi to lo and divide by two and make even
*
         move.l a3,d3                   ;hi; index base included
         move.l d3,d0
         add.l a2,d0                    ;lo
         asr.l #1,d0
         bclr #0,d0
         move.w 0(a6,d0.l),d0
*
*                  Multi get-element routine (indirect)
* Get the partition element for each array and store
* Include "excluded" arrays
*
        movem.l d4-d6/a3-a5,-(a7)
        move.l a5,a3
        move.l d0,d7                    ;awkward all this
mlt_igl
        movem.l (a3)+,d0/d5-d6/a0/a4-a5
        move.l d7,d0                    ;get el num
        mulu d6,d0                      ;multiply by elsize
        add.l a5,d0                     ;add base
        move.l d0,-12(a3)               ;put pp in place
mlt_ig
        dbra d4,mlt_igl
        movem.l (a7)+,d4-d6/a3-a5
*
mind_uloop
         move.w 0(a6,d2.l),d0
         bsr mlt_dcmpel
         ble.s mind_lloop
         addq.l #2,d2                   ;add elsize => point to next
         bra.s mind_uloop
mind_lloop
         move.w 0(a6,d3.l),d0           ;-> next
         bsr mlt_dcmpel
         bge.s mind_swap
         subq.l #2,d3                   ;-> previous
         bra.s mind_lloop
mind_swap
         cmp.l d3,d2
         bgt.s mind_stack
         beq.s mind_redgap

         move.w 0(a6,d2.l),d0
         move.w 0(a6,d3.l),0(a6,d2.l)
         move.w d0,0(a6,d3.l)
*
mind_redgap
         addq.l #2,d2                   ;move pointers closer
         subq.l #2,d3
         cmp.l d3,d2
         ble.s mind_uloop
mind_stack
         cmp.l a2,d3                    ;pointers cross?
         ble.s mind_nostk
         move.l a2,-(a7)
         move.l d3,-(a7)
mind_nostk
         move.l d2,a2
         cmp.l a3,d2
         blt mind_partition
         cmpi.l #-1,(a7)                        ;test recursion depth
         bne mind_qsort
         addq.l #4,a7                   ;remove end marker
         moveq #0,d0
         rts                            ;goto to s_exit
*
         end
