* arrinfo Get information on and array
* PWITTE March 19th 1993
*
        section code

        xdef cmpinfo         ;get details of the array;comp% contruct
        xdef arrinfo         ;get general details of array
        xdef indinfo         ;get details of the index%!array;comp%
                             ; construct
*
mxcmp   equ 5                ;max no cmp codes (at present) 1 to 4 (input)
mxop    equ 6                ;the max number of operators we can take at
                             ; present: from 0 to 5
*
indinfo
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Look for the [index%!][#]array;comp%  construct
* and return err BP if not found
*
* only items marked with an asterix are filled in in the current subroutine
*
* input:  a1 ->  ri.stack (for cmpinfo routine)
*        a3 ->  entry in name table
* output: d0.l = negative error code or 0
*        d2.w = seperator info after main array
*        d3.w = main array type  -1 = str, 0 = fp, 1 = int
*        d5.l = ssssssss|ssssssss|oooooooo|cccccccc
*        d5.h = a/d indicator with pos => ascending and neg => descending
*        d5.w   (msb) is operator ?, =, >, <, >=, <=, <>, ==, >>
*        d5.b = (lsb) is comparison type 0 - 3 ++
*               if type is given as zero d5.b = -1 ie array is excluded
*               currently default is d5.l = 0
*        d6.l = main array element step size
*        d7.l = highest element number = count
*               if index < array count = max index
*               if no index or index size =array size then count = max array
*        a4 ->  0th element of array
*       * a2 ->  0th element of index or zero (if no index)
*        a3 ->  next parameter (unless error)
*
        suba.l a2,a2                    ;assume no index
        moveq #-1,d7                    ;min array size: not important
        cmpi.w #$343,0(a6,a3.l)         ;is par integer array followed by
                                        ; an exclamation mark?
        bne.s cmpinfo                   ; no, not an index
        bsr.s arrinfo                   ;get the index info
        bne.s ci_rts
        movea.l a4,a2                   ;flag index. a2->index base

*
cmpinfo
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Lookout for the [#]array[;comp%] construct and return err BP if not found
*
* input:  d7.l = previous count or -1 (don't care)
*        a1 ->  ri.stack
*        a3 ->  entry in name table
* output: d0.l = 0 or error code
*      *  d2.w = info on last seperator
*        d3.w = type  -1 = str, 0 = fp, 1 = int
*      *  d5.l = ssssssss|ssssssss|oooooooo|cccccccc
*      *  d5.h = a/d indicator with pos => ascending and neg => descending
*      *  d5.w   (msb) is operator ?, =, >, <, >=, <=, <>, ==, >>
*      *  d5.b = (lsb) is comparison type 0 - 3 ++
*               if type is given as zero d5.b = -1 ie array is excluded
*               currently default is d5.l = 0
*        d6.l = element step size
*        d7.l = highest (legal) element number = count
*        a1 and ri.stack remain unchanged
*        a4 ->  0th element
*      *  a3 ->  next parameter (unless error)
*
        bsr.s arrinfo
        bne.s ci_rts
        moveq #0,d5             ;default
        cmpi.w #$20,d2          ;was last par followed by semi-colon?
        bne.s ci_noerr          ; no, then not ours
        cmp.l a5,a3             ;any more parameters?
        bge.s ci_bp             ;no, must be a mistake
*
        move.w 0(a6,a3.l),d2    ;get last seperator info
        movem.l d1-d6/a0/a2/a3/a5,-(a7)
        lea.l 8(a3),a5          ;get 1 par only
        move.w $112,a2          ;get or convert to int
        jsr (a2)
        movem.l (a7)+,d1-d6/a0/a2/a3/a5
        bne.s ci_rts
        addq.l #8,a3            ;point to next par
        move.w 0(a6,a1.l),d5    ;get condcmp%
        addq.l #2,a1            ;restore stack pointer
        move.l a1,$58(a6)
        move.w d5,d0
        ext.w d5                ;let sign perculate up to d5.l
        ext.l d5
        bpl.s ci_pl
        neg.b d0                ;cmp itself should be positive
ci_pl
        move.w d0,d5            ;restore op temporarily
        andi.l #$000000ff,d0    ;isolate cmp
        divu #mxcmp,d0          ;get the
        swap d0                 ; remainder after division
        move.b d0,d5            ;put cmp back
        move.w d5,d0            ;what type of op?
        bmi.s ci_opneg          ;query!
        lsr.w #8,d0             ;put op where we can get at it
        divu #mxop,d0           ;max ops allowed at present
        swap d0                 ;we want the remainder (modulus)
        asl.b #2,d0             ;convert to internal format (long offsets)
        ror.w #8,d0             ;move back into msb
        or.b d5,d0              ;append cmp
ci_opneg
        move.w d0,d5            ;restore to order
        subq.b #1,d5            ;convert cmp to internal type
ci_noerr
        moveq #0,d0
ci_rts
        rts
ci_bp
        moveq #-15,d0
        rts
*
arrinfo
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                       Get array details
* Look for [#]array, where the hash (#) indicates a name-table
* pointer rather than the array parameter itself
*
* input:  d7.l = previous count or -1 (don't care)
*        a3 ->  entry in name table
* output: d0.l = negative error code or 2
*       * d2.w = seperator following array
*       * d3.w = type  -1 = str, 0 = fp, 1 = int
*       * d6.l = element step size
*       * d7.l = highest element number = count
*       * a4 ->  0th element
*       * a3 ->  next parameter (unless error)
*        d5     smashed. On error only d3 smashed
*
        move.l d7,-(a7)
        btst #7,1(a6,a3.l)      is parameter hashed?
        bne arrhash
        cmpi.b #3,0(a6,a3.l)    ;is parameter an array?
        bne.s ai_bp
        move.w 0(a6,a3.l),d2
        moveq #$0f,d3        ;type mask
        and.b d2,d3
        beq.s ai_bp          ;internal substrings not wanted
        andi.w #$70,d2       ;peel off all but seperator info
*
        move.l a2,-(a7)
        movea.l 4(a6,a3.l),a2   ;pointer to array descriptor
        adda.l $28(a6),a2            ;is offset from bv.vvbas
        move.w 4(a6,a2.l),d5    ;d5.w = number of dimensions
        movea.l $28(a6),a4
        add.l 0(a6,a2.l),a4     ;a4 -> 0th element
        addq.l #4,a2         ;point to dimensional info
*
        moveq #1,d7          ;d7 = total number elements
        subq.w #2,d3         ;convert type to - 0 +
        beq.s ai_fp
        bgt.s ai_in
* ai_st
        move.w d5,d0         ;number of dimensions
        mulu #4,d0           ;make long
        add.l a2,d0          ;
        move.w -4(a6,d0.l),d6   ;d6 = element len

* There's a problem here with smsq: If only a single element A$(0 to 0),
* the type doesn't show up as a substring, as in JS, but the descriptor is
* not a normal array desriptor at all! July 15th 2000

        cmpi.w #1,d6
        bne.s all_as_normal

        moveq #1,d7          set count to 1
        bra.s continue_here

all_as_normal
        ext.l d6                     ;d6.l = el len
        subq.w #1,d5         ;we're finished with this dimension
        bra.s ai_cont
ai_in
        moveq #2,d6
        bra.s ai_cont
ai_fp
        moveq #6,d6
ai_cont
        move.w 2(a6,a2.l),d0
        addq.w #1,d0         ;add 1 for 0'th element
        mulu d0,d7
        addq.l #4,a2
        subq.w #1,d5
        bgt.s ai_cont

continue_here
        move.l (a7)+,a2
ai_chx                        ;basic index test
        move.l (a7)+,d0       ;get last count
        bmi.s ai_exit         ;if "don't care" skip this. d7 = count
        cmp.w d7,d0           ;if array <= last count
        bpl.s ai_exit         ;ok if this array same or greater than count
        move.l d0,d7          ;count is always smallest size
ai_exit
        addq.l #8,a3         ;successful, so point to next par
        moveq #0,d0          ;no errors
        rts
ai_bp
        moveq #-15,d0
ai_rts
        addq.l #4,a7
        tst.l d0
        rts
*
arrhash
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get array details. Look for the #arrinfo$[;] construct: a 10 byte string
* containing the array details. Should only be called via arrinfo as it stands
*
* structure of the string:
* 0 = len     (.w)
* 2 = type    (.w) -1 = str, 0 = fp, 1 = int
* 4 = elsize  (.w) 2 for int, 6 for fp, len+2 for str
* 6 = count   (.w) number of elements
* 8 = pointer (.l) pointer to values
*
* input:  a3 ->  entry in name table
* output: d0.l = negative error code or 0
*       * d2.l = d2.hi = min array size
*       * d2.w = seperator info
*       * d3.w = type  -1 = str, 0 = fp, 1 = int
*       * d6.l = element step size (elsize)
*       * d7.l = highest element number = count
*       * a4 ->  0th element
*       * a3 ->  next parameter (unless error)
*
        move.w 0(a6,a3.l),d2
        andi.w #%0000000001110000,d2    ;skim off all but seperator info
        movem.l d1-d4/a0/a2/a5,-(a7)
        lea.l 8(a3),a5                  ;get one par at a time
        move.w $116,a2
        jsr (a2)
        movem.l (a7)+,d1-d4/a0/a2/a5
        bne.s ai_rts
        cmpi.w #10,0(a6,a1.l)
        bne.s ai_bp                       ;any other string len suspicious
        move.w 2(a6,a1.l),d3            ;d3 = type
        move.w 4(a6,a1.l),d6            ;d6 = elsize
        ext.l d6                        ;has to be long
        move.w 6(a6,a1.l),d7            ;d7 = count
        ext.l d7
        movea.l 8(a6,a1.l),a4           ;base pointer (0th element)
        lea.l 12(a1),a1                 ;reset ri stack
        move.l a1,$58(a6)
        bra.s ai_chx

        end
