* MATFIND Look for an item in and array using  the "Brute force" method
* PWITTE May 8th 1994
*
        section code

        xdef    MATFIND
        xdef    find

        xref    ms_start
        xref    ms_ret
        xref    op_adjust

*
MATFIND
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* SuperBASIC function to locate an element in an array using the sequential
* search method. If the item is found it's position or pointer number is
* returned, else -1.
*
* psn% = MATFIND ( [index% !] [#]array [; comparison_type%] , item )
*       where index% is an integer array of no more than DIMN(array) elements
*             each element being a unique pointer to an element in array
*             or a negative number (which is ignored)
*       and   array is a single or multiple (but does it make sense?)
*             dimensioned array of any current qdos type, or an array slice
*             of more than one element
*        or   a reference to an array as above preceded by a hash
*       and   comparison_type% is the type of comparison required
*             types are as for Qdos type + 1
*             Default = 1 = Qdos type 0
*       and   item is the item being searched for. This will be treated as
*             of the same type as the array.
*
        moveq   #-1,d1              flag FIND
        bra     ms_start            init

find
        tst.w   d5                  ;what kind of operator?
        bpl.s   mf_opok             ;positive op's ok
        andi.w  #$00ff,d5           ;assume equals was meant
mf_opok
        move.l  a2,d0               ;indexed?
        beq.s   mf_dir
* mf_ind
        move.l  a2,-(a7)
        bsr.s   ind_find
        move.l  (a7)+,a0
        beq.s   mf_notfound         ;result of op was false
        suba.l  a0,a2
        move.l  a2,d4
        asr.l   #1,d4
        bra.s   mf_ret
mf_notfound
        moveq   #-1,d4
        bra     ms_ret
mf_dir
        movea.l a5,a0               ;a0 -> array base
        bsr.s   dir_find
        beq.s   mf_notfound         ;result of op was false
        suba.l  a5,a0               ;zero base
        move.l  a0,d4
        beq.s   mf_ret
        divu    d6,d4               ;convert pointers to numbers
mf_ret
        moveq   #0,d0
        bra     ms_ret
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                      Find sub-routine (direct)
*
* input : d5.l  comp type (see marrinfo for details)
*         d6.l = element size
*         d7.l = count
*         a0 -> array base address
*         a1 -> comparison variable
*         a4 -> comp routine
* output : d0 = result of search: 0 = found, <>0 = not found
*         a0 -> position if found, nonsense if not found
*         flags set
*
*         d1-d2/d7/a0 smashed.
dir_find
        moveq   #-1,d0              ;assume not found
        bra.s   dir_flend
dir_floop
        bsr     op_adjust
        bne.s   dir_found           ;found when "true"!
        adda.l  d6,a0
dir_flend
        dbra    d7,dir_floop
dir_found
mf_rts
        rts

*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                      Find sub-routine (indexed)
*
* input : d5.l  comp type (see marrinfo for details)
*         d6.l = element size (array)
*         d7.l = count (index)
*         a1 -> comparison variable
*         a2 -> index base address
*         a4 -> comp routine
*         a5 -> array base address
* output : d0 = result of search: 0 = found, <>0 = not found
*         a2 ->> position if found, nonsense if not found
*         flags set
*
*         d1-d2/d7/a0 smashed.
ind_find
        moveq   #-1,d0              ;assume not found
        bra.s   ind_flend
ind_floop
        move.w  0(a6,a2.l),d0
        bmi.s   ind_flend
        mulu    d6,d0               ;convert to offset
        lea.l   0(a5,d0.l),a0
        bsr     op_adjust
        bne.s   ind_found           ;found when "true"
        addq.l  #2,a2
ind_flend
        dbra    d7,ind_floop
ind_found
        rts
*
        end
