* MATEQU - S*Basic procedure to make one array equal to another
*
* pjwitte 1993-2006
* V0.02 Tidied code but nothing changed as its too much trouble. It works!

        section code

        xdef MATEQU


*
MATEQU
        moveq #16,d0            test for two pars only
        add.l a3,d0             number of pars required * 8 in d0
        sub.l a5,d0
        bne.s err_bp

        bsr.s arrinfo
        bne.s err_bp

        movem.l d3/d5/a2/a4,-(a7)
        addq.l #8,a3            point to next par
        bsr.s arrinfo           and get it's info

        movem.l (a7)+,d2/d4/a0/a3 put array1 info elsewhere
        exg a0,a3               movem.l won't do it
        cmp.w d3,d2             too many dimensions?
        bne.s err_or             no can do

        cmp.w d5,d4             are types same?
        bne.s err_bp             sorry

        movea.l a2,a5           a5 -> arr2 descriptor
        movea.l a3,a1           a1 -> arr1 descriptor
        moveq #1,d0             d0 = total number of elements
*
        moveq #0,d1             prepare for long
        bra.s dcl_end


*
arrinfo
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                          Array information
* inputs:  a3->name table entry (all pointer relatve to a6)
* returns: a4-> 0'th element; a2-> array descriptor
*         d3 = number of dimensions; d5 = type: -1=str, 0=fp, 1=int
*         d0 = nonzero if not an array
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
        move.w 0(a6,a3.l),d0    get identifyer
        move.w d0,d5            d5.b: x1 = str; x2 = fp; x3 = int
        andi.w #$f00,d0         remove unimportant info
        cmpi.w #$300,d0         is it an array?
        bne.s pmexit

        andi.w #$f,d5           we don't want substring
        beq.s err_bp

        subq.w #2,d5            convert type

        movea.l 4(a6,a3.l),a2
        adda.l $28(a6),a2       base of variables value area
        move.w 4(a6,a2.l),d3    d3 = no dimensions
        movea.l $28(a6),a4
        add.l 0(a6,a2.l),a4     a4 -> 0'th element

exit_ok
        moveq #0,d0             no errors

pmexit
        rts


*
dimcomp_loop                    ; a3 -> arrdes1 a2 -> arrdes2
        move.w 6(a6,a3.l),d1
        cmp.w 6(a6,a2.l),d1     compare max index: arr1 must be >= arr2
        bne.s err_bp

        addq.l #1,d1            for the 0'th dimension
        mulu d1,d0
        bvs.s err_or

        addq.l #4,a3
        addq.l #4,a2

dcl_end
        dbra d2,dimcomp_loop


*
arrcopy
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*            Long word mover (including one trailing word)
* Inputs:  a4 -> FROM address (Rel a6)
*         a0 -> TO   address (Rel a6)
*         d0.l = number of bytes to shift
*       ***  all affected registers altered     ***
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
*        bsr.s arrsize           a4 -> arr2; a0 -> arr1; d2 = no long; d0 = bytes


*
arrsize
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*  To work out the total size of an array
*  Inputs:  d0.l = multiple of all dimensions: i x j x k x l x n
*          d1.l = last dimension (for string only)
*          d5   = type: -1 str, 0 float, 1 int
*  Returns: d0.l = number of bytes
*          d1/d3 smashed
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
        tst.w d5
        bmi.s acstr
        beq.s acfp

        moveq #2,d1             number of bytes/element
        bra.s arrc

*
err_or
        moveq #-4,d0
        rts

*
err_bp
        moveq #-15,d0
        rts

*
acstr
        divu d1,d0              (n + 1) * size / n
        addq.w #1,d1
        mulu d1,d0              add extra for length component for each dim
        bvs.s err_or
*
        bra.s ac                element size is 1

acfp
        moveq #6,d1             number of bytes/element

*
arrc                            ; d0 = total number of elements in all dims
                                ; d1 = element size
        mulu d1,d0              d0 = no els * b/el = no bytes to shift
        bvs.s err_or            overflow

*
ac
        move.l d0,d2            save count as bytes to test for remainder
        lsr.l #2,d2             shift d2.l longwords

arrshift
        move.l 0(a6,a4.l),0(a6,a0.l)
        addq.l #4,a4
        addq.l #4,a0
        subq.l #1,d2
        bne.s arrshift

        btst #1,d0           remainder?
        beq.s exit_ok

        move.w 0(a6,a4.l),0(a6,a0.l)

        bra.s exit_ok

*
        end
