*   Selection of sub-routines ( mainly for arrays in this configuration )
*   Sub-routines to compare integers, floats, and strings; and to
*   Swap two elements of those types
*
* V0.02 January 18th 2007
* V0.03 January 26th 2007 bug fix in comp

        section code

        xdef str_comp           ;address of ut.cstr routine

        xdef int_sub            ;type-dependent subroutines
        xdef flt_sub
        xdef str_sub
        xdef mlt_sub            ;not presently used
        xdef int_cmp
        xdef flt_cmp
        xdef str_cmp
        xdef op_adjust
*
el_swp  equ 0
el_cmp  equ 2
*
mlt_sub                         ;dummy routine
        rts
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Common features of comparison routines:
*
* input : a0  -> comp item 1
*         a1  -> comp item 1
*         d5.l = comp type (see below)
* output : d0.l = result: -, 0, +
*         d1.l = ? (flt_cmp only)
*
* Current implementation of types:
*  a/d       only + or - in whole of msw of d5 implemented (for quick testing)
*
*  comparison 0  :  case dependent
*             1  :  case dependent embedded numbers compared numerically
*             2  :  case independent
*             3  :  case independent otherwise as for 1
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Common features of all swap routines: (these are rather specialised and not
* really for general use
*
* input : a0  -> comp item 1
*         a1  -> comp item 1
*         d2  -> object
*         d3  -> target

* output : a0  -> object
*          d0  =  ?
*
* str_swp: d7 = counter, d1/a1 = ?
*
int_swap
        move.w 0(a6,d2.l),d0
        move.w 0(a6,d3.l),0(a6,d2.l)
        move.w d0,0(a6,d3.l)
        bra.s s_ppadjust
str_swap
        move.l d2,d1
        move.l d3,a1
        move.w d6,d7
        lsr.w #2,d7
        bcc.s str_clend
        move.w 0(a6,d1.l),d0
        move.w 0(a6,a1.l),0(a6,d1.l)
        move.w d0,0(a6,a1.l)
        addq.l #2,d1
        addq.l #2,a1
        bra.s str_clend
str_cloop
        move.l 0(a6,d1.l),d0
        move.l 0(a6,a1.l),0(a6,d1.l)
        move.l d0,0(a6,a1.l)
        addq.l #4,d1
        addq.l #4,a1
str_clend
        dbra d7,str_cloop
        bra.s s_ppadjust
flt_swap
        move.w 0(a6,d2.l),d0
        move.w 0(a6,d3.l),0(a6,d2.l)
        move.w d0,0(a6,d3.l)
        move.l 2(a6,d2.l),d0
        move.l 2(a6,d3.l),2(a6,d2.l)
        move.l d0,2(a6,d3.l)
*
s_ppadjust
        cmp.l d2,a0                     ;maintain pointer at partition
        bne.s s_s1
        move.l d3,a0                    ;we just swapped out the part-
        rts                             ; ition pointer: this restores it
s_s1
        cmp.l d3,a0
        bne.s s_s2
        move.l d2,a0                    ;for multi- this item (a0) must be
s_s2                                    ; included both for in and out of
        rts                             ; memory!!
*
int_sub
        bra.s int_swap
*       bra.s int_cmp
int_cmp
        move.w 0(a6,a0.l),d0
        cmp.w 0(a6,a1.l),d0
        beq.s eq
        blt.s mi
pl
        moveq #1,d0
        bra.s dora
str_sub
        bra.s str_swap
*       bra.s str_cmp
str_cmp
* ***********
        move.l  d2,-(a7)                ;bug in smsq?
        moveq   #0,d2
*        clr.w   d0
* ***********
        move.b d5,d0
str_comp
        jsr 0
* **********
        move.l  (a7)+,d2
* **********
dora
        tst.l   d5
        bmi.s dora_chs
        tst.l d0
        rts
dora_chs
        neg.l d0
        rts
flt_sub
        bra.s flt_swap
*       bra.s flt_cmp
*
flt_cmp                                 ;cmp.f f1,f0; where
        move.l 2(a6,a0.l),d0
*        move.l 2(a6,a1.l),d1            ;f1=current, f0=partel
*        eor.l d0,d1
        cmp.l 2(a6,a1.l),d0
        bvc.s flt_ss                    ;sign same
        tst.l d0                        signs different so
        bra.s flt_done                  ; return comparison
flt_ss
        tst.l d0                        ;signs positive?
        bmi.s flt_neg
        move.w 0(a6,a0.l),d1
        cmp.w 0(a6,a1.l),d1             ;how do exps compare?
        bne.s flt_done                  ; different magnitude
        cmp.l 2(a6,a1.l),d0             ;same magnitude
flt_done
        bmi.s mi
        beq.s eq
        moveq #1,d0
        bra.s dora
eq
        moveq #0,d0
        bra.s dora
mi
        moveq #-1,d0
        bra.s dora
flt_neg
        move.w 0(a6,a1.l),d1
        cmp.w 0(a6,a0.l),d1
        bne.s flt_done
        cmp.l 2(a6,a1.l),d0
        bra.s flt_done
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Comparison using operators to return true or false
*
* input : d5.l = cmp type:
*           d5.l   (msw) a/d converter
*           d5.w   (msb) operator
*           d5.b   comaprison type
*         a0  -> comp item 1
*         a1  -> comp item 1
*         a4  -> comp subroutine (type dependent)
* output : d0.l = result: true (1) or false (0)
*         d1.l = ? (flt_cmp only)
*
* Current implementation of types:
*  operators (?  : -1 same as direct comp) not permitted
*            =  :  0 equals
*            >= :  1 greater than or equal to
*            <= :  2 less than or equal to
*            >  :  3 greater than
*            <  :  4 less than
*            <> :  5 different than / not equal to
*
*  permitted a/d & comparisons as described in comp above
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
op_adjust
*
        move.w d5,d0
        lsr.w #8,d0             ;d0 contains operator
        pea op_eval(pc,d0.w)
op_do
        jmp (a4)                ;compare (unless wild!)

op_eval
        beq.s ret1           ; =
        bra.s ret0
*
        bpl.s ret1           ; >=
        bra.s ret0
*
        ble.s ret1           ; <=
        bra.s ret0
*
        bgt.s ret1           ; >
        bra.s ret0
*
        bmi.s ret1           ; <
        bra.s ret0
*
        bne.s ret1           ; <>
ret0
        moveq #0,d0
        rts
ret1
        moveq #1,d0
        rts
*

        end
