*                       Array MULTI Info
*                      PWITTE April 4th 1993
*
        section code

        xdef mltinfo
        xdef ms_exit            ;forced no error return
        xdef ms_quit            ;return with error (if any)
        xdef getsub

        xref indinfo            ;util_marrinfo
        xref cmpinfo
        xref int_sub            ;type-related subroutines
        xref flt_sub
        xref str_sub
        xref mlt_sub
*
getsub
        tst.w d3                ;array type
        bmi.s qs_s
        beq.s qs_f
qs_i
        lea.l int_sub,a4
        rts
qs_f
        lea.l flt_sub,a4
        rts
qs_s
        lea.l str_sub,a4
qs_rts
        rts
*
*

mltinfo
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                       Get info on multiple arrays
*
* input and output as for indinf/cmpinfo except:
*
*       a4 -> type-dependent routines and
*       d4.l = number of arrays - 1, a5 -> mem
*       d3/d5/d6 meaningless in this connection
*
* First count the number of arrays, over and above the first, to order
*
        move.l $58(a6),a1       ;get stack pointer
        bsr indinfo             ;get all relevant array info
        bne.s qs_rts
ms_multi
*
* Get further details of multiple arrays
*
        move.l a3,-(a7)         ;save parameter pointer
        moveq #1,d1             ;d1=counter. We've got one already
        bra.s ms_cmp            August 31st 2003
ms_cloop
        cmp.b #3,0(a6,a3.l)     ;array?
        bne.s ms_a0             ; no
        bra.s ms_a1             ; yes, increment and move to next
ms_a0
        btst #7,1(a6,a3.l)      ; - a reference to an array, then?
        beq.s ms_a2
ms_a1                           ;perhaps - assume so anyway for now
        addq.l #1,d1            ;count++
ms_a2
        addq.l #8,a3            ;array or not array, try next par
ms_cmp
        cmpa.l a3,a5
        bgt.s ms_cloop
*
        move.l (a7)+,a3
        move.l d1,d4            ;d4=number of arrays
*
* Reserve some memory for array data
*
        mulu #24,d1             ;each array requires 6 long words storage
        movem.l d2-d3/a1-a3,-(a7)
        moveq #-1,d2            ;job owner is this job
        moveq #$18,d0           ;mt.alchp
        trap #1
        movem.l (a7)+,d2-d3/a1-a3
        tst.l d0
        bne.s qs_rts
*
* Now get the info for each array and stack in memory
*
        subq.l #1,d4            ;dbra count
        movem.l d2/d4/d7/a0/a2,-(a7)
ms_gal
        move.l a4,d2            ;d2 = array base address
        bsr getsub              ;get relevant sub address

        move.l d3,(a0)+         ;store details of this array in memory
        move.l d5,(a0)+         *      Mem structure:
        move.l d6,(a0)+         *
        clr.l (a0)+             * 20 arrbas  (a5)  base of array
        move.l a4,(a0)+         * 16 routad  (a4)  address to routines
        move.l d2,(a0)+         * 12 ppoint  (a0)  pointer to comp item
        tst.w d4                *  8 elsize  (d6)  size of element
        beq.s ms_2              *  4 cmptyp  (d5)  comp type & direction
        move.l (a7),d2          *  0 artype  (d3)  str flt int
        bsr cmpinfo
        bne.s ms_q1
        dbra d4,ms_gal
ms_2
        moveq #0,d0
ms_q1
        movem.l (a7)+,d2/d4/d7/a0/a2
        movea.l a0,a5
        bne.s ms_quit
        lea.l mlt_sub,a4
        tst.l d0
        rts
ms_exit
        moveq #0,d0
ms_quit
        move.l d0,d4            ;save error
        move.l a5,a0            ;mem base
        moveq #$19,d0           ;mt.rechp
        trap #1
        move.l d4,d0
        rts
*
        end
